Next: fputs, Previous: fpurge, Up: Stdio [Contents][Index]

### 4.20 `fputc`, `fputc_unlocked`—write a character on a stream or file

Synopsis

    #include <stdio.h>
    int fputc(int ch, FILE *fp);

    #define _BSD_SOURCE
    #include <stdio.h>
    int fputc_unlocked(int ch, FILE *fp);

    #include <stdio.h>
    int _fputc_r(struct _rent *ptr, int ch, FILE *fp);

    #include <stdio.h>
    int _fputc_unlocked_r(struct _rent *ptr, int ch, FILE *fp);

Description
`fputc` converts the argument ch from an `int` to an `unsigned char`, then writes it to the file or stream identified by fp.

If the file was opened with append mode (or if the stream cannot support positioning), then the new character goes at the end of the file or stream. Otherwise, the new character is written at the current value of the position indicator, and the position indicator oadvances by one.

For a macro version of this function, see `putc`.

`fputc_unlocked` is a non-thread-safe version of `fputc`. `fputc_unlocked` may only safely be used within a scope protected by flockfile() (or ftrylockfile()) and funlockfile(). This function may safely be used in a multi-threaded program if and only if they are called while the invoking thread owns the (FILE *) object, as is the case after a successful call to the flockfile() or ftrylockfile() functions. If threads are disabled, then `fputc_unlocked` is equivalent to `fputc`.

The `_fputc_r` and `_fputc_unlocked_r` functions are simply reentrant versions of the above that take an additional reentrant structure argument: ptr.

Returns
If successful, `fputc` returns its argument ch. If an error intervenes, the result is `EOF`. You can use ‘`ferror(fp)`’ to query for errors.

Portability
`fputc` is required by ANSI C.

`fputc_unlocked` is a BSD extension also provided by GNU libc.

Supporting OS subroutines required: `close`, `fstat`, `isatty`, `lseek`, `read`, `sbrk`, `write`.

Next: fputs, Previous: fpurge, Up: Stdio [Contents][Index]